; configurable depacker
; use 64tass v1.5+
            apd_src       = $f4
            apd_bitbuffer = $f6
            apd_lwm       = $f7
            apd_length    = $f8
            apd_offset    = $fa
            apd_source    = $fc
            apd_dest      = $fe

*       =   $0801
        .word (+), 2005  ;pointer, line number
        .null $9e, format("%d", start);will be sys 4096
+       .word 0          ;basic line end

start:      lda     #end_depack & $ff
            sta     apd_src
            lda     #end_depack >> 8
            sta     apd_src+1
            lda     #end_file & $ff
            sta     apd_dest
            lda     #end_file >> 8
            sta     apd_dest+1
            sei
; break 81e  sw reset  1991448
            jsr     depack
            cli
            rts

depack:     lda     #$80
            sta     apd_bitbuffer
            asl
            tay
read_lit:   #getbyte
write_lit:  sta     (apd_dest), y
            inc     apd_dest
            bne     clear_lwm
            inc     apd_dest+1
clear_lwm:  sty     apd_lwm         ; lwm = 0;
read_flag:  #mgetbitd               ; if (aP_getbit(&ud))...
            bcc     read_lit        ; #1
            #mgetbitd
            bcc     large_match     ; #11
            #mgetbitd
            bcc     short_match     ; #111
            lda     #%11100000      ; for (i = 4; i > 0; i--)
mini_match: #mgetbit
            rol                     ; offs = (offs << 1) + getBit();
            bcs     mini_match      ; if (offs == 0)
            beq     write_lit       ; destination[destinationOffset] = 0;
            sbc     apd_dest        ; else
            eor     #%11111111      ; destination[destinationOffset] = destination[destinationOffset - offs];
            sta     apd_source
            tya
            sbc     apd_dest+1
            eor     #%11111111
            sta     apd_source+1
            lda     (apd_source), y
            bne     write_lit       ; bra
apd_end:    rts
short_match:#getbyte                ; #110  offs = source[sourceOffset++] & 0xff;
            lsr                     ;       offs >>= 1;
            beq     apd_end         ; if (offs > 0) {
            sta     apd_offset
            sty     apd_offset+1
            lda     #1              ; len = 2 + (offs & 0x0001);
            rol
            sta     apd_length
            sty     apd_length+1
            bne     set_lwm         ; bra
large_match:jsr     getgamma        ; #10   offs = getGamma();
            cmp     #2              ; if ((lwm == 0) && (offs == 2)) {
            bne     offset_mat
            cpy     apd_lwm
            bne     offset_mat
            jsr     getgamma        ; r0 = offs ; len = getGamma();
            bcc     set_lwm         ; bra

offset_mat: lsr     apd_lwm         ; if (lwm == 0) offs -= 3
            sbc     #2              ; else offs -= 2;
            sta     apd_offset+1    ; offs <<= 8;
            #getbyte
            sta     apd_offset      ; offs += source[sourceOffset++] & 0xff;
            jsr     getgamma        ; r0 = offs; len = getGamma();

            lda     apd_offset+1    ; if (offs < 128) len += 2;
            bne     al_chkh
            bit     apd_offset
            bmi     set_lwm
            lda     #2
            bcc     al_add          ; bra
al_chkh:    cmp     #>1280          ; if (offs >= 1280) len++;
            bcc     set_lwm
            cmp     #>32000         ; if (offs >= 32000) len += 2;
            tya
            adc     #1
al_add:     adc     apd_length
            sta     apd_length
            bcc     set_lwm
            inc     apd_length+1

set_lwm:    lda     #1
            sta     apd_lwm         ; lwm = 1
            sec                     ; source = dest - offset;
            lda     apd_dest
            sbc     apd_offset
            sta     apd_source
            lda     apd_dest+1
            sbc     apd_offset+1
            sta     apd_source+1
            ldx     apd_length+1
            beq     cm_skip
cm_loop1:   lda     (apd_source), y
            sta     (apd_dest), y
            iny
            bne     cm_loop1
            inc     apd_source+1
            inc     apd_dest+1
            dex
            bne     cm_loop1
cm_skip:    ldx     apd_length
            beq     cm_end
cm_loop2:   lda     (apd_source), y
            sta     (apd_dest), y
            iny
            dex
            bne     cm_loop2
            clc
            tya
            adc     apd_dest
            sta     apd_dest
            bcc     cm_end
            inc     apd_dest+1
cm_end      ldy     #0
            jmp     read_flag

getgamma:   sty     apd_length+1
            lda     #1
getgamma1:  #mgetbit
            rol
            rol     apd_length+1
            #mgetbit
            bcs     getgamma1
            sta     apd_length
            rts

getbyte .macro
            lda     (apd_src), Y
            inc     apd_src
            bne     getbyte1
            inc     apd_src+1
getbyte1:
        .endm

mgetbit .macro
            asl     apd_bitbuffer
            bne     m_getbit1
            pha
            #getbyte
            rol
            sta     apd_bitbuffer
            pla
m_getbit1:
        .endm

mgetbitd .macro
            asl     apd_bitbuffer
            bne     m_getbit2
            #getbyte
            rol
            sta     apd_bitbuffer
m_getbit2:
        .endm

end_depack: .binary  "alice.pck"
end_file: